;============================================================================================
; ddwbmp2.asm    DirectX  Load bmp in Window Mode
; GoAsm v 0.53
; Programmed by AsmGges         asmges@aol.com          http://www.chez.com/asmgges/index.htm
;--------------------------------------------------------------------------------------------
; Compile.bat:
; GoAsm ddwbmp2
; GoLink ddwbmp2.obj user32.dll kernel32.dll gdi32.dll ddraw.dll
;============================================================================================

;directx
 DDLOCK_WAIT              = 01h
 DDSCL_EXCLUSIVE          = 010h
 DDSCL_FULLSCREEN         = 01h
 DDSCL_NORMAL             = 08h
 DDSD_CAPS                = 01h
 DDSD_BACKBUFFERCOUNT     = 020h
 DDSCAPS_BACKBUFFER       = 04h
 DDSCAPS_PRIMARYSURFACE   = 0200h
 DDSCAPS_FLIP             = 010h
 DDSCAPS_COMPLEX          = 08h
 DDLOCK_SURFACEMEMORYPTR  = 0h
 DDSD_PITCH               = 08h
 DDERR_SURFACELOST        = 0887601C2h
 DDERR_WASSTILLDRAWING    = 08876021Ch
 DDWAITVB_BLOCKBEGIN      = 01h
 DDBLT_WAIT               = 01000000h
 DDFLIP_WAIT              = 01h
 DDSCAPS_FRONTBUFFER      = 020h
 DDSD_HEIGHT              = 02h
 DDSD_WIDTH               = 04h
 DDSCAPS_OFFSCREENPLAIN   = 040h
 DDBLTFAST_NOCOLORKEY     = 00h
 DDBLTFAST_WAIT           = 010h
 DDSCAPS_SYSTEMMEMORY     = 0800h
 DDCKEY_SRCBLT            = 08h
 DDBLTFAST_SRCCOLORKEY    = 01h

;DirectDraw
 DD_QueryInterface          = 000h
 DD_AddRef                  = 004h
 DD_Release                 = 008h
 DD_Compact                 = 00Ch
 DD_CreateClipper           = 010h
 DD_CreatePalette           = 014h
 DD_CreateSurface           = 018h
 DD_DuplicateSurface        = 01Ch
 DD_EnumDisplayModes        = 020h
 DD_EnumSurfaces            = 024h
 DD_FlipToGDISurface        = 028h
 DD_GetCaps                 = 02Ch
 DD_GetDisplayMode          = 030h
 DD_GetFourCCCodes          = 034h
 DD_GetGDISurface           = 038h
 DD_GetMonitorFrequency     = 03Ch
 DD_GetScanLine             = 040h
 DD_GetVerticalBlankStatus  = 044h
 DD_Initialize              = 048h
 DD_RestoreDisplayMode      = 04Ch
 DD_SetCooperativeLevel     = 050h
 DD_SetDisplayMode          = 054h
 DD_WaitForVerticalBlank    = 058h

;DirectDrawSurface
 DDS_QueryInterface         = 000h
 DDS_AddRef                 = 004h
 DDS_Release                = 008h
 DDS_AddAttachedSurface     = 00Ch
 DDS_AddOverlayDirtyRect    = 010h
 DDS_Blt                    = 014h
 DDS_BltBatch               = 018h
 DDS_BltFast                = 01Ch
 DDS_DeleteAttachedSurface  = 020h
 DDS_EnumAttachedSurfaces   = 024h
 DDS_EnumOverlayZOrders     = 028h
 DDS_Flip                   = 02Ch
 DDS_GetAttachedSurface     = 030h
 DDS_GetBltStatus           = 034h
 DDS_GetCaps                = 038h
 DDS_GetClipper             = 03Ch
 DDS_GetColorKey            = 040h
 DDS_GetDC                  = 044h
 DDS_GetFlipStatus          = 048h
 DDS_GetOverlayPosition     = 04Ch
 DDS_GetPalette             = 050h
 DDS_GetPixelFormat         = 054h
 DDS_GetSurfaceDesc         = 058h
 DDS_Initialize             = 05Ch
 DDS_IsLost                 = 060h
 DDS_Lock                   = 064h
 DDS_ReleaseDC              = 068h
 DDS_Restore                = 06Ch
 DDS_SetClipper             = 070h
 DDS_SetColorKey            = 074h
 DDS_SetOverlayPosition     = 078h
 DDS_SetPalette             = 07Ch
 DDS_Unlock                 = 080h
 DDS_UpdateOverlay          = 084h
 DDS_UpdateOverlayDisplay   = 088h
 DDS_UpdateOverlayZOrder    = 08Ch

;DirectDrawClipper
 DDC_QueryInterface     = 000h
 DDC_AddRef             = 004h
 DDC_Release            = 008h
 DDC_GetClipList        = 00Ch
 DDC_GetHWnd            = 010h
 DDC_Initialize         = 014h
 DDC_IsClipListChanged  = 018h
 DDC_SetClipList        = 01Ch
 DDC_SetHWnd            = 020h

;Windows
 IDI_APPLICATION      = 07F00h
 IDC_ARROW            = 07F00h
 BLACK_BRUSH          = 04h
 SM_CXSCREEN          = 00h
 SM_CYSCREEN          = 01h
 SW_SHOWDEFAULT       = 0Ah
 PM_NOREMOVE          = 00h
 WM_CLOSE             = 010h
 WM_ACTIVATE          = 06h
 WM_KEYDOWN           = 0100h
 VK_ESCAPE            = 01Bh
 IMAGE_BITMAP         = 00h
 LR_CREATEDIBSECTION  = 02000h
 LR_LOADFROMFILE      = 010h
 SRCCOPY              = 0CC0020h

;program
 W_SCREEN   = 640  
 H_SCREEN   = 480  

;============================================================================================

.CONST

ClassName    db ' AsmGges Win32Asm',0
MsgDdError   db 'Direct Draw: failed',0
MsgDataError db 'Opening data file: failed',0
GgesTitle    db '[demo] GoAsm directX Load Bmp AsmGges Win32 Assembly',0
BmpFile      db 'GoSite.bmp',0

align 4

;============================================================================================

.DATA

DDSURFACEDESC:
    dwSize   dd 06Ch 
    dwFlags  dd 0
    dwHeight dd 0
    dwWidth  dd 0
    lPitch: dwLinearSize dd 0
    dwBackBufferCount    dd 0
    dwMipMapCount: dwZBufferBitDepth: dwRefreshRate dd 0
    dwAlphaBitDepth   dd 0
    dwReserved        dd 0
    lpSurface         dd 0
    ddckCKDestOverlay dd 0,0
    ddckCKDestBlt     dd 0,0
    ddckCKSrcOverlay  dd 0,0
    ddckCKSrcBlt      dd 0,0
    ddpfPixelFormat:
        dwSize2  dd 32
        dwFlags2 dd 0
        dwFourCC dd 0
        dwRGBBitCount: dwYUVBitCount: dwZBufferBitDepth2 dwAlphaBitDepth2: dd 0
        dwRBitMask: dwYBitMask dd 0
        dwGBitMask: dwUBitMask dd 0
        dwBBitMask: dwVBitMask dd 0
        dwRGBAlphaBitMask: dwYUVAlphaBitMask dd 0
    ddsCaps dd 0

DDCOLORKEY: 
    dwColorSpaceLowValue  dd 0  
    dwColorSpaceHighValue dd 0

RECT:  
    Left    dd 0    
    Top     dd 0   
    Right   dd 0        
    Bottom  dd 0

RECT1: 
    Left1   dd 0    
    Top1    dd 0   
    Right1  dd W_SCREEN
    Bottom1 dd H_SCREEN 

RECT2: 
    Left2   dd 0    
    Top2    dd 0   
    Right2  dd 0        
    Bottom2 dd 0  

;bmp
BITMAP:
    bmType       dd 0
    bmWidth      dd 0
    bmHeight     dd 0
    bmWidthBytes dd 0
    bmPlanes     dw 0
    bmBitsPixel  dw 0
    bmBits       dw 0

align 4

;Windows
WNDCLASS: 
    style         dd 0
    lpfnWndProc   dd WndProc
    cbClsExtra    dd 0
    cbWndExtra    dd 0
    hInstance     dd 0
    hIcon         dd 0
    hCursor       dd 0
    hbrBackground dd 0
    lpszMenuName  dd 0
    lpszClassName dd ClassName

;messages
MSG: 
    MSG_hwnd    dd 0    
    MSG_message dd 0    
    MSG_wParam  dd 0    
    MSG_lParam  dd 0
      
    MSG_time    dd 0    
    MSG_pt.x    dd 0    
    MSG_pt.y    dd 0

DDSPrimary dd ?
DDSBack    dd ?   
lpClipper  dd ?   
DDSFond    dd ?
Object     dd ?  
WinHandle  dd ?
bActive    db ?
align 4
HBarTitle  dd ?
hBitmap    dd ?  
hdcImage   dd ?  
hbmOld     dd ?  
hdc        dd ?  

;============================================================================================

.CODE

START:

    invoke GetModuleHandleA, 0
    mov [hInstance],eax

    invoke LoadIconA, [hInstance], IDI_APPLICATION
    mov [hIcon],eax

    invoke LoadCursorA, 0, IDC_ARROW
    mov [hCursor],eax

    invoke GetStockObject, BLACK_BRUSH
    mov [hbrBackground],eax

    invoke RegisterClassA, addr WNDCLASS

    invoke GetSystemMetrics, SM_CXSCREEN
    sub eax,W_SCREEN
    shr eax,1
    mov [Left2],eax

    mov D[Left],0
    mov D[Top],0
    mov D[Right],W_SCREEN
    mov D[Bottom],H_SCREEN
    invoke AdjustWindowRectEx, addr RECT, 04CA0000h , 0, 0

    mov eax,[Bottom]
    sub eax,[Top]
    sub eax,H_SCREEN
    sub eax,3
    mov [HBarTitle],eax

    invoke GetSystemMetrics,SM_CYSCREEN
    sub eax,H_SCREEN
    sub eax,[HBarTitle]
    shr eax,1
    mov [Top2],eax

    mov eax,H_SCREEN
    add eax,[HBarTitle]

    invoke CreateWindowExA, 0, addr ClassName, addr GgesTitle, 04CA0000h, [Left2], [Top2], \
                            W_SCREEN, eax, 0, 0, [hInstance], 0 
    mov [WinHandle],eax

    invoke ShowWindow, [WinHandle], SW_SHOWDEFAULT
    invoke UpdateWindow, [WinHandle]

    ;----------------
    ; DirectDraw init
    ;----------------
    invoke DirectDrawCreate, 0, addr Object, 0
    or  eax,eax
    jnz >>DdrawError

    ;---------
    ; Win Mode
    ;---------
    push DDSCL_NORMAL
    push [WinHandle]
    mov eax,[Object]
    push eax
    mov eax,[eax]
    call [eax+DD_SetCooperativeLevel]
    or  eax,eax
    jnz >>DdrawError

    ;------------------------
    ; Create: primary surface
    ;------------------------
    mov D[dwFlags],DDSD_CAPS
    mov D[ddsCaps],DDSCAPS_PRIMARYSURFACE

    push 0
    push addr DDSPrimary
    push addr DDSURFACEDESC
    mov eax,[Object]
    push eax
    mov eax,[eax]
    call [eax+DD_CreateSurface]
    or  eax,eax
    jnz >>DdrawError

    ;---------------------
    ; Create: Back surface
    ;---------------------
    mov D[dwFlags],DDSD_CAPS+DDSD_HEIGHT+DDSD_WIDTH
    mov D[ddsCaps],DDSCAPS_OFFSCREENPLAIN
    mov D[dwWidth],W_SCREEN
    mov eax,H_SCREEN
    add eax,[HBarTitle]
    mov [dwHeight],eax

    push 0
    push addr DDSBack
    push addr DDSURFACEDESC
    mov eax,[Object]
    push eax
    mov eax,[eax]
    call [eax+DD_CreateSurface]
    or  eax,eax
    jnz >>DdrawError

    ;----------------
    ; Create: clipper
    ;----------------
    push 0
    push addr lpClipper
    push 0         
    mov eax,[Object]
    push eax
    mov eax,[eax]
    call [eax+DD_CreateClipper]
    or  eax,eax
    jnz >>DdrawError

    push [WinHandle]
    push 0
    mov eax,[lpClipper]
    push eax
    mov eax,[eax]
    call [eax+DDC_SetHWnd]
    or  eax,eax
    jnz >>DdrawError

    push [lpClipper]
    mov eax,[DDSPrimary]
    push eax
    mov eax,[eax]
    call [eax+DDS_SetClipper]
    or  eax,eax
    jnz >>DdrawError

    ;---------------------
    ; Create: Fond surface
    ;---------------------
    mov D[dwFlags],DDSD_CAPS+DDSD_HEIGHT+DDSD_WIDTH
    mov D[ddsCaps],DDSCAPS_OFFSCREENPLAIN+DDSCAPS_SYSTEMMEMORY
    mov D[dwWidth],W_SCREEN
    mov D[dwHeight],H_SCREEN

    push 0
    push addr DDSFond
    push addr DDSURFACEDESC
    mov eax,[Object]
    push eax
    mov eax,[eax]
    call [eax+DD_CreateSurface]
    or  eax,eax
    jnz >>DdrawError

    ;---------
    ; Load bmp
    ;---------
    invoke LoadBmp, addr BmpFile, [DDSFond]
    or  eax,eax
    jnz >>DataError

;============================================================================================

GameLoop:

    ;----------------------
    ; Refresh: Back surface
    ;----------------------
    mov D[Left],0
    mov D[Top],0
    mov D[Right],W_SCREEN
    mov D[Bottom],H_SCREEN

    push DDBLTFAST_NOCOLORKEY+DDBLTFAST_WAIT
    push addr RECT
    push [DDSFond]
    push 0
    push 0
    mov eax,[DDSBack]
    push eax
    mov eax,[eax]
    call [eax+DDS_BltFast]
    or  eax,eax
    jnz >>DdrawError

;============================================================================================

MessageLoop:

    invoke PeekMessageA, addr MSG, 0, 0, 0, PM_NOREMOVE

    cmp eax,0
    je >L2
        invoke GetMessageA, addr MSG, 0, 0, 0
        cmp eax,0
        jne >L1
            jmp ExitGame
        L1: 

        invoke TranslateMessage, addr MSG
        invoke DispatchMessageA, addr MSG
        jmp <MessageLoop
    L2: 

    cmp B[bActive],0
    jne >L1
        invoke WaitMessage
        jmp <MessageLoop
    L1:

    mov eax,[DDSPrimary]
    push eax
    mov eax,[eax]
    call [eax+DDS_IsLost]

    cmp eax,0
    je  >L2
        cmp eax,DDERR_SURFACELOST
        jne >L1
            mov eax,[DDSPrimary]
            push eax
            mov eax,[eax]
            call [eax+DDS_Restore]
            jmp >L2
        L1: 
        jmp ExitGame
    L2: 

    invoke GetWindowRect, [WinHandle], addr RECT2

    ;-----
    ; Flip
    ;-----  
    mov eax,[Left2]
    add eax,W_SCREEN
    mov [Right2],eax
    
    mov eax,[Top2]
    add eax,[HBarTitle]
    mov [Top2],eax

    add eax,H_SCREEN
    mov [Bottom2],eax

    push 0
    push DDBLT_WAIT
    push addr RECT1
    push [DDSBack]
    push addr RECT2
    mov eax,[DDSPrimary]
    push eax
    mov eax,[eax]
    call [eax+DDS_Blt]
    or  eax,eax
    jnz >DdrawError

    jmp GameLoop

;============================================================================================

DdrawError:
    mov eax,addr MsgDdError
    jmp >Error

DataError:
    mov eax,addr MsgDataError

Error:
    invoke MessageBoxA, [WinHandle], eax, addr ClassName, 0
    invoke DestroyWindow, [WinHandle]
    invoke PostQuitMessage, 1
    jmp MessageLoop

ExitGame:
    invoke ExitProcess, [MSG_wParam]

;============================================================================================

WndProc FRAME hwnd, uMsg, wParam, lParam

    pushad

    cmp D[uMsg],WM_CLOSE
    jne >L1
        call LibereSurf      
        jmp >L3
    L1:

    cmp D[uMsg],WM_ACTIVATE
    jne >L1 
        mov eax,[wParam]
        mov [bActive],al
        jmp >L3
    L1:

    cmp D[uMsg],WM_KEYDOWN
    jne >L2
        cmp D[wParam],VK_ESCAPE
        jne >L3
            call LibereSurf    
            jmp >L3
    L2:
  
        popad
        invoke DefWindowProcA, [hwnd], [uMsg], [wParam], [lParam]
        jmp >L1
    L3:

    popad
    mov eax,0

L1:

    ret
ENDF

;============================================================================================
;-----------------
; Release surfaces
;-----------------
LibereSurf:

    cmp D[Object],0
    je  L2
        cmp D[DDSFond],0
        je  >L1
            mov eax,[DDSFond]
            push eax
            mov eax,[eax]
            call [eax+DDS_Release]
            mov D[DDSFond],0
        L1:
         
        cmp D[lpClipper],0
        je  >L1
            mov eax,[lpClipper]
            push eax
            mov eax,[eax]
            call [eax+DDC_Release]
            mov D[lpClipper],0
        L1:

        cmp D[DDSBack],0
        je  >L1
            mov eax,[DDSBack]
            push eax
            mov eax,[eax]
            call [eax+DDS_Release]
            mov D[DDSBack],0
        L1:
                   
        cmp D[DDSPrimary],0
        je  >L1
            mov eax,[DDSPrimary]
            push eax
            mov eax,[eax]
            call [eax+DDS_Release] 
            mov D[DDSPrimary],0
        L1:

        mov eax,[Object]
        push eax
        mov eax,[eax]
        call [eax+DD_Release]
        mov D[Object],0
    L2:

    invoke PostQuitMessage, 0

    ret

;============================================================================================

LoadBmp FRAME BmpFilename,Surface

    invoke LoadImageA, 0, [BmpFilename], IMAGE_BITMAP, 0, 0, \
                       LR_CREATEDIBSECTION+LR_LOADFROMFILE
    or  eax,eax
    jz  >BmpError

    mov [hBitmap],eax

    invoke GetObjectA, [hBitmap], 24, addr BITMAP

    invoke CreateCompatibleDC, 0
    mov [hdcImage],eax

    invoke SelectObject, [hdcImage], [hBitmap]
    mov [hbmOld],eax

    push addr hdc
    mov eax,[Surface]
    push eax
    mov eax,[eax]
    call [eax+DDS_GetDC]
    or eax,eax
    jnz >L1
        invoke BitBlt, [hdc], 0, 0, [bmWidth], [bmHeight], [hdcImage], 0, 0, SRCCOPY

        push [hdc]
        mov eax,[Surface]
        push eax
        mov eax,[eax]
        call [eax+DDS_ReleaseDC]
    L1:

    invoke SelectObject, [hdcImage], [hbmOld]
    invoke DeleteObject, [hBitmap]
    invoke DeleteDC, [hdcImage]

    push addr DDCOLORKEY
    push DDCKEY_SRCBLT
    mov eax,[Surface]
    push eax
    mov eax,[eax]
    call [eax+DDS_SetColorKey]
    or  eax,eax
    jz >L2 
    
BmpError:
    mov eax,1

    L2:

    ret
ENDF

;============================================================================================
;============================================================================================